<?php
// includes
require_once('inc/db_wrapper.php');
require_once('inc/db_login.inc.php');
require_once('lib/user.php');
session_start();
require_once('inc/defines.inc.php');
require_once('lib/functions.php');
require_once('lib/framework.php');
require_once('lib/specific.php');
require_once('lib/table_editor.php');
require_once('a_authorize.php');
// end includes

switch($_GET[action])
{
	case 'settings':
		//main settings, import/export
		require_once('modules/a_settings.php');
	break;
	
	case 'logout':
		//admin log out
		require_once('modules/a_logout.php');
	break;
	
	case 'stats':
		//main settings, import/export
		require_once('modules/a_stats.php');
	break;
	
	case 'fields':
		//fields
		require_once('modules/a_fields.php');
	break;
	
	case 'users':
		//manage users		
		require_once('modules/a_users.php');
	break;
	
	case 'urls':
		//manage users		
		require_once('modules/a_urls.php');
	break;
	
	case 'newsletters':
		//list saved newsletter
		require_once('modules/a_newsletters.php');
	break;
	
	case 'import':
		//import/export users
		require_once('modules/a_import.php');
	break;
	
	case 'sync':
		//import/export users
		require_once('modules/a_sync.php');
	break;
	
	default:
		//send/save newsletter
		require_once("modules/a_main.php");
	break;
}

require_once('templates/a_master.html');
?>
