<?php
/*
These are funcitons related to presentation, html and forms
*/

function redirect($where)
{
   echo "<script language=javascript type=text/javascript>
   self.location.href='".$where."';
   </script>";
}

function alert($what)
{
   $GLOBALS[jsalert]="<script language=javascript type=text/javascript>
   alert('$what');
   </script>";
}

// often used function which creates a navigation in the bottom of the page
// when there are too many records to be listed at one
function nav_pages($path,$count,$offset,$limit,$width=760)
{
   if(!is_numeric($limit)) return true;
	
   if(empty($offset)) $offset=0;
   if(empty($limit)) $limit=10;
      
   //need previous link?
   if($offset>0)
   {
      $off=$offset-$limit;
      $previous="<a href=\"".$path."&offset=".$off."\">&lt;&lt; Previous</a>";
   }
   else $previous="";

   //need next link?
   if(($offset+$limit)<$count)
   {
      $off=$offset+$limit;
      $next="<a href=\"".$path."&offset=".$off."\">Next &gt;&gt;</a>";
   }
   else $next="";   

   //generate nubmers of pages between
   $pages=$count/$limit;
   
   if(strstr($pages,"."))
   {
      $pages=substr($pages,0,strpos($pages,"."));
      $pages++;
   }   

   $curpage=$offset/$limit;
   
   $links="";
   for($i=0;$i<$pages;$i++)
   {
      $j=$i+1;
      if($i==$curpage) $links.="<a href=\"".$path."&offset=".($limit*$i)."\"><b>(".$j.")</b></a>&nbsp; ";
      else $links.="<a href=\"".$path."&offset=".($limit*$i)."\">".$j."</a>&nbsp; ";
   }
  
   echo "<table width=".$width." align=center class=MAIN_text>";
   echo "<tr><td width=100>";
   echo $previous;
   echo "</td><td width=".($width-200)." align=center>";
   if($count) echo "Pages: ".$links;
   echo "</td><td width=100>";
   echo $next;
   echo "</td></tr></table>";
}

function msg_die($message)
{
  die("<link rel=stylesheet href=templates/styles.css>
  <br><br><br>
  <table align=center width=500 style='border:1px solid red;' cellpadding=10>
  <tr><th style='background:red;'>Error!</th></tr>
  <tr><td align=center>$message<br><br>
  <a href=javascript:history.back();>Go Back</a></td></tr><table>");
}

function date_format2($date,$noyear=0)
{	
   $months=array('','Jan','Feb','Mar','Apr','May','Jun','Jul',
   'Aug','Sep','Oct','Nov','Dec');

   $date=explode(" ",$date);
   $time=$date[1];
   $date=$date[0];
   
   $date=explode("-",$date);
   
   if($date[1]<10) $date[1]=substr($date[1],1);
   if($noyear)
   {
	  $datestring=$months[$date[1]]." ".$date[2];
   }
   else
   {   
      $datestring=$months[$date[1]].", ".$date[2]." ".$date[0];
   }   
   
   $datestring.=" ".$time;
   return $datestring;
}


//to print a date chooser - get name and value in mysql date format
function date_chooser($name,$value="")
{
	global $months;
	
	if(empty($value)) $value=date("Y-m-d");
	
	$parts=explode("-",$value);
	
	$day=$parts[2]+0;
	$month=$parts[1]+0;
	$year=$parts[0];
	
	$chooser="";
	
	$chooser.="<select name=".$name."month>";
	for($i=1;$i<=12;$i++)
	{
		if($i==$month) $selected='selected';
		else $selected='';
		$chooser.="<option $selected value=$i>$months[$i]</option>";
	}
	$chooser.="</select> / ";
	
	$chooser.="<select name=".$name."day>";
	for($i=1;$i<=31;$i++)
	{
		if($i==$day) $selected='selected';
		else $selected='';
		$chooser.="<option $selected>$i</option>";
	}
	$chooser.="</select> / ";
	
	$chooser.="<select name=".$name."year>";
	for($i=2004;$i<=2050;$i++)
	{
		if($i==$year) $selected='selected';
		else $selected='';
		$chooser.="<option $selected>$i</option>";
	}
	$chooser.="</select> ";	
	
	return $chooser;
}

//creates a dropdown options in select menu
function form_sdropdown($values,$displays,$sel='')
{
	foreach($values as $cnt=>$value)
	{
		if(is_array($sel))
		{
			//for multiple selections
			if(in_array($value,$sel)) $selected='selected';
			else $selected='';
		}
		else
		{
			//single selection
			if($sel==$value) $selected='selected';
			else $selected='';
		}
		$options.="<option $selected value=\"$value\">$displays[$cnt]</option>";
	}
	
	return $options;
}


//creates a dropdown options in select menu
// receives hash of values
function form_cdropdown($hashes,$val,$display,$sel='')
{
	foreach($hashes as $cnt=>$hash)
	{
		if(is_array($sel))
		{			
			//multiple selection
			if(in_array($hash[$val],$sel)) $selected='selected';
			else $selected='';
		}
		else
		{
			if($sel==$hash[$val]) $selected='selected';
			else $selected='';
		}
		$options.="<option $selected value=\"$hash[$val]\">$hash[$display]</option>\n";
	}
	return $options;
}

function get_setting($name)
{
	global $DB, $T_SETTINGS;
	
	$q="SELECT value FROM $T_SETTINGS
	WHERE name=\"$name\"";
	$value=$DB->oq($q);
	
	return $value;
}

function set_setting($name)
{
	global $DB, $T_SETTINGS;
	
	//setting exists?
	$q="SELECT id FROM $T_SETTINGS
	WHERE name=\"$name\"";
	$exists=$DB->oq($q);

	if($exists)
	{	
		$q="UPDATE $T_SETTINGS SET
		value=\"".$_POST[$name]."\"
		WHERE name=\"$name\"";
		$DB->q($q);
	}
	else
	{
		$q="INSERT INTO $T_SETTINGS (name,value)
		VALUES (\"$name\",\"".$_POST[$name]."\")";
		$DB->q($q);
	}
}

/**
 * Dumps array of values in a DB table
 *
 * An easy way to do an insert query. All fields that exist 
 * both in the table and in the passed array will be included in the query.
 *
 * @access	public
 * @param   string
 * @param   array
 * @return	true
 */	
function dumpto_table($table,$vars)
{
	global $DB;

	//select fields from table
	$q="SHOW FIELDS FROM $table";
	$fields=$DB->aq($q);
	
	$q="INSERT INTO $table (";

	foreach($fields as $field)
	{
		if(isset($vars[$field['Field']]))
		{
			$q.=$field['Field'].",";
		}
	}
	
	$q=substr($q,0,strlen($q)-1);
	
	$q.=") VALUES (";

	foreach($fields as $field)
	{
		if(isset($vars[$field['Field']]))
		{
			if(is_array($vars[$field['Field']]))
			{
				$valstr=implode("|",$vars[$field['Field']]);
				$valstr=mysql_real_escape_string($valstr);
				$q.="\"$valstr\",";
			}
			else
			{
				$vars[$field['Field']]=mysql_real_escape_string($vars[$field['Field']]);
				$q.="\"".$vars[$field['Field']]."\",";
			}
		}
	}
	$q=substr($q,0,strlen($q)-1);
	$q.=")";
	$DB->q($q);
	
	$lid=$DB->lid();
	
	return $lid;
}

/**
 * Updates a DB table with the values in a passed array
 *
 * An easy way to do an update query. All fields that exist 
 * both in the table and in the passed array will be included in the query.
 *
 * @access	public
 * @param   string
 * @param   array
 * @param   string
 * @param   mixed
 * @return	true
 */	
function update_table($table,$vars,$fld,$vle)
{
	global $DB;

	//select fields from table
	$q="SHOW FIELDS FROM $table";
	$fields=$DB->aq($q);

	$q="UPDATE $table SET ";

	foreach($fields as $field)
	{
		if(isset($vars[$field['Field']]))
		{
			if(is_array($vars[$field['Field']]))
			{
				$valstr=implode("|",$vars[$field['Field']]);
				$valstr=mysql_real_escape_string($valstr);
				$q.="$field[Field]=\"$valstr\", ";
			}
			else
			{
				$vars[$field['Field']]=mysql_real_escape_string($vars[$field['Field']]);
				$q.="$field[Field]=\"".$vars[$field['Field']]."\", ";				
			}
		}
	}

	$q=substr($q,0,strlen($q)-2);
	
	$q.=" WHERE $fld='$vle' ";

	$DB->q($q);
}

function encrypt($string, $key) 
{ 
	$result = ''; 
	for($i=0; $i<strlen($string); $i++) 
	{ 
		$char = substr($string, $i, 1); 
		$keychar = substr($key, ($i % strlen($key))-1, 1); 
		$char = chr(ord($char)+ord($keychar)); 
		$result.=$char; 
	}
	
	return base64_encode($result); 	
}

function decrypt($string, $key) 
{ 
	$result = ''; 
	$string = base64_decode($string);
	
	for($i=0; $i<strlen($string); $i++) 
	{ 
		$char = substr($string, $i, 1); 
		$keychar = substr($key, ($i % strlen($key))-1, 1); 
		$char = chr(ord($char)-ord($keychar)); 
		$result.=$char; 
	}

	return $result; 
}
?>