<?php
// includes
require_once('inc/db_wrapper.php');
require_once('inc/db_login.inc.php');
require_once('inc/defines.inc.php');
require_once('lib/functions.php');
require_once('lib/framework.php');
require_once('lib/specific.php');
require_once('lib/table_editor.php');
// end includes

$q="SELECT value FROM $T_SETTINGS
WHERE name='register'";
$register=$DB->oq($q);

$efields=array();

if(!$register)
{
	msg_die("Registration is disallowed");
}

$optin=get_setting("optin");

if(!empty($_POST[ok]))
{
	//duplicate email?
	$q="SELECT id FROM $T_USERS WHERE email=\"$_POST[email]\"";
	$exists=$DB->oq($q);
	
	if($exists)
	{
		msg_die("This email is already registered in the system.");
	}
	
	$active=$optin?0:1;
	
	$q="INSERT INTO $T_USERS (name,email,active,date,ip)
	VALUES (\"$_POST[name]\",\"$_POST[email]\",'$active',CURDATE(),'$_SERVER[REMOTE_ADDR]')";
	$DB->q($q);
	
	$mid=$DB->lid();

	$mainmsg="Thank you";
	$msg="You have been signed up in the system.";
	
	if($optin) 
	{
		//generate code
		$code=substr(md5($_POST[email].time()),0,8);
		
		//update member
		$q="UPDATE $T_USERS SET
		code=\"$code\"
		WHERE id='$mid'";
		$DB->q($q);
		
		$msg.="However confirmation of your email address is required. Please check your email and click on the link in it to confirm your address";
		
		$subject="Please confirm your email for ".get_setting("site");
		$message="Please click on the link below to confirm your email address:
<a href=\"".SITE_URL."confirm.php?id=$mid&code=$code\">".SITE_URL."confirm.php?id=$mid&code=$code</a>";		
		send_mail(get_setting("sender"),$_POST[email],$subject,$message);
	}
	
	$template="templates/message.html";
}
else
{
	$template="templates/register.html";
}

require_once('templates/master.html');
?>
