<?php
//prefix for tables in database
$prefix="bfl_";

//names of the tables
$T_USERS=$prefix.'users';
$T_SETTINGS=$prefix.'settings';
$T_SMAILS=$prefix.'smails';

//supress error displaying
$old_error_reporting = error_reporting(E_ALL & ~(E_NOTICE));

//get & post short typing
$_GET=$_GET?$_GET:$HTTP_GET_VARS;
$_POST=$_POST?$_POST:$HTTP_POST_VARS;
$_FILES=$_FILES?$_FILES:$HTTP_POST_FILES;

//months array for date format
$months=array('','January','February','March','April','May','June','July','August',
'September','October','November','December');

//letters
$letters=array("A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z");

$offset=$_GET['offset']?$_GET['offset']:0;

// try to switch off magic quotes
if (get_magic_quotes_gpc()) {
    function stripslashes_deep($value)
    {
        $value = is_array($value) ?
                    @array_map('stripslashes_deep', $value) :
                    stripslashes($value);

        return $value;
    }

    $_POST = @array_map('stripslashes_deep', $_POST);
    $_GET = @array_map('stripslashes_deep', $_GET);
    $_COOKIE = @array_map('stripslashes_deep', $_COOKIE);
    $_REQUEST = @array_map('stripslashes_deep', $_REQUEST);
}

//clear dangerous input
function clear_input($input)
{	
	$input=is_array($input)?$input:array();
	
	while (list ($key,$val) = each ($input)) 
	{    
		$input[$key]=str_replace("<script","&lt;script",$val);				
	    $input[$key]=str_replace("</script>","&lt;/script&gt;",$input[$key]);				
		
		if(!is_array($input[$key]))
		{
			$input[$key] = addslashes($input[$key]);				
		}
    }
        
    return $input;
}

$_POST=clear_input($_POST);
$_GET=clear_input($_GET);

//user parametters
define('PAGE_LIMIT',10);
define('SENDER','info@calendarscripts.info');
if(is_object($DB))
{	
	$q="SELECT value FROM $T_SETTINGS WHERE name='site_url'";
	$site_url=$DB->oq($q);
	define('SITE_URL',$site_url);	
	
	$q="SELECT value FROM $T_SETTINGS
	WHERE name='sender'";
	$sender=$DB->oq($q);
	define('DEFAULT_SENDER',$sender);
	
	$q="SELECT value FROM $T_SETTINGS
	WHERE name='is_limited'";
	$is_limited=$DB->oq($q);
	define('IS_LIMITED',$is_limited);	
}
?>
