<?php
require_once('inc/defines.inc.php');
require_once('lib/functions.php');
require_once('lib/framework.php');
require_once('inc/db_wrapper.php');
require_once('inc/db_login.inc.php');	

if(!empty($_POST['ok']))
{
	//create tables
	$q="DROP TABLE IF EXISTS `bfl_settings`";
	$DB->q($q);
	
	$q="CREATE TABLE `bfl_settings` (
    `id` tinyint(3) unsigned NOT NULL auto_increment,
    `name` varchar(255) NOT NULL default '',
    `value` text NOT NULL,
    PRIMARY KEY  (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8";
	$DB->q($q);
	
	//insert settings
	$q="INSERT INTO `bfl_settings` VALUES (1, 'adminpass', \"$_POST[admpass]\");";
	$DB->q($q);	
	
	$q="INSERT INTO `bfl_settings` VALUES (2, 'register', '0');";
	$DB->q($q);
	
	$q="INSERT INTO `bfl_settings` VALUES (4, 'sender', 'you@yourwebsite.com');";
	$DB->q($q);
	
		
	$q="INSERT INTO `bfl_settings` VALUES (15, 'preserve', '1');";
	$DB->q($q);
	
	$q="INSERT INTO `bfl_settings` VALUES (16, 'site_url', '$_POST[site_url]');";
	$DB->q($q);
	
	$q="INSERT INTO `bfl_settings` VALUES (17, 'footer', '');";
	$DB->q($q);
	
	$q="DROP TABLE IF EXISTS `bfl_smails`;";
	$DB->q($q);
	
	$q="CREATE TABLE `bfl_smails` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `sender` varchar(255) NOT NULL default '',
  `receiver` varchar(255) NOT NULL default '',
  `subject` varchar(255) NOT NULL default '',
  `message` text NOT NULL,
  `date` date NOT NULL default '0000-00-00',
  `mailtype` varchar(10) default NULL,
  `track` tinyint(3) unsigned not null,
  `sent` int(10) unsigned NOT NULL,
  `read` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8";
	$DB->q($q);
	
	$q="DROP TABLE IF EXISTS `bfl_users`;";
	$DB->q($q);
	
	$q="CREATE TABLE `bfl_users` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `email` varchar(255) NOT NULL default '',
  `name` varchar(255) NOT NULL default '',
  `active` tinyint(3) unsigned NOT NULL default '0',
  `date` date NOT NULL default '0000-00-00',
  `notes` text NOT NULL,
  `code` varchar(100) NOT NULL,
  `bounces` TINYINT UNSIGNED NOT NULL,
  `ip` VARCHAR( 20 ) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `email` (`email`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8";
	$DB->q($q);
	
	$q="ALTER TABLE `bfl_users` ADD UNIQUE (`email`)";
	$DB->q($q);
	
	
	alert("The installation is done! Delete install.php for security reasons! ");
	redirect("admin.php");	
}
else
{
	$pagetitle="BroadFast Lite Installation";
	$template="templates/install.html";
	require_once("templates/master.html");
}
?>
