<?php
/*
General program funcitions
*/

function send_mail($from,$to,$subject,$message,$ctype='text/html')
{  
   $mail_mime .= "MIME-Version: 1.0\n";
   $mail_mime .= "Content-Type: $ctype;\n";
  
   $texte .=$message;
    
   if(!mail($to, $subject, $texte,"Reply-to: $from\nFrom: $from\n".$mail_mime)) echo ("Cannot send mail.");
}

function upload_file($name, $dir="files/",$newname="")
{	
   if(!empty($_FILES[$name]))
   {
	  $name_filename=$_FILES[$name]['name'];

      //getting extension of the file
      $parts=explode(".",$name_filename);
      $extension=$parts[sizeof($parts)-1];
      $extension=strtolower($extension);
      
      $extension=".$extension";      

      if(empty($newname))
	  {
	     $newname=md5(time()).$extension;
	  }
	  
      @copy($_FILES[$name]['tmp_name'],$dir.$newname);

      }
   return $newname;
}

//to uptput CSV
function Output($buffer,$name='')
{
	//Output PDF to some destination
	global $HTTP_SERVER_VARS;
	
	//Normalize parameters
	if($name=='')
	{
		$name='users.csv';		
	}
	//Download file
	if(isset($HTTP_SERVER_VARS['HTTP_USER_AGENT']) and strpos($HTTP_SERVER_VARS['HTTP_USER_AGENT'],'MSIE'))
		Header('Content-Type: application/force-download');
	else
		Header('Content-Type: application/octet-stream');
		if(headers_sent())
				msg_die('Some data has already been output to browser, can\'t send the file');
			Header('Content-Length: '.strlen($buffer));
			Header('Content-disposition: attachment; filename='.$name);
			echo $buffer;
	return '';
}


function cut($start,$end,$word,$testvar=0)
{	
	$word=substr($word,strpos($word,$start)+strlen($start));
	
	$word=substr($word,0,strpos($word,$end));
	if($testvar) die($start." ".$end."<br>".$word);
	return $word;
}

//help function for making tumbnails
function resampimagejpg($forcedwidth, $forcedheight, $sourcefile, $destfile, $imgcomp=0)
{
   $g_imgcomp=100-$imgcomp;
   $g_srcfile=$sourcefile;
   $g_dstfile=$destfile;
   $g_fw=$forcedwidth;
   $g_fh=$forcedheight;

   if(file_exists($g_srcfile))
   {
     $g_is=getimagesize($g_srcfile);
     if(($g_is[0]-$g_fw)>=($g_is[1]-$g_fh))
     {
        $g_iw=$g_fw;
        $g_ih=($g_fw/$g_is[0])*$g_is[1];
     }
     else
     {
        $g_ih=$g_fh;
        $g_iw=($g_ih/$g_is[1])*$g_is[0]; 
     }
     $img_src=imagecreatefromjpeg($g_srcfile);
     $img_dst=imagecreatetruecolor($g_iw,$g_ih);
     imagecopyresampled($img_dst, $img_src, 0, 0, 0, 0, $g_iw, $g_ih, $g_is[0], $g_is[1]);
     imagejpeg($img_dst, $g_dstfile, $g_imgcomp);
     imagedestroy($img_dst);
   return true;
   }
   else
   return false;
}

//help function for making tumbnails
function resampimagepng($forcedwidth, $forcedheight, $sourcefile, $destfile, $imgcomp=0)
{
   $g_imgcomp=100-$imgcomp;
   $g_srcfile=$sourcefile;
   $g_dstfile=$destfile;
   $g_fw=$forcedwidth;
   $g_fh=$forcedheight;

   if(file_exists($g_srcfile))
   {
     $g_is=getimagesize($g_srcfile);
     if(($g_is[0]-$g_fw)>=($g_is[1]-$g_fh))
     {
        $g_iw=$g_fw;
        $g_ih=($g_fw/$g_is[0])*$g_is[1];
     }
     else
     {
        $g_ih=$g_fh;
        $g_iw=($g_ih/$g_is[1])*$g_is[0]; 
     }
     $img_src=imagecreatefrompng($g_srcfile);
     $img_dst=imagecreatetruecolor($g_iw,$g_ih);
     imagecopyresampled($img_dst, $img_src, 0, 0, 0, 0, $g_iw, $g_ih, $g_is[0], $g_is[1]);
     imagepng($img_dst, $g_dstfile, $g_imgcomp);
     imagedestroy($img_dst);
   return true;
   }
   else
   return false;
}

//help function for making tumbnails
function resampimagegif($forcedwidth, $forcedheight, $sourcefile, $destfile, $imgcomp=0)
{
   $g_imgcomp=100-$imgcomp;
   $g_srcfile=$sourcefile;
   $g_dstfile=$destfile;
   $g_fw=$forcedwidth;
   $g_fh=$forcedheight;

   if(file_exists($g_srcfile))
   {
     $g_is=getimagesize($g_srcfile);
     if(($g_is[0]-$g_fw)>=($g_is[1]-$g_fh))
     {
        $g_iw=$g_fw;
        $g_ih=($g_fw/$g_is[0])*$g_is[1];
     }
     else
     {
        $g_ih=$g_fh;
        $g_iw=($g_ih/$g_is[1])*$g_is[0]; 
     }
     $img_src=imagecreatefromgif($g_srcfile);
     $img_dst=imagecreate($g_iw,$g_ih);
     imagecopyresampled($img_dst, $img_src, 0, 0, 0, 0, $g_iw, $g_ih, $g_is[0], $g_is[1]);
     imagegif($img_dst, $g_dstfile, $g_imgcomp);
     imagedestroy($img_dst);
   return true;
   }
   else
   return false;
}

function make_thumbnail($path,$name)
{
   $forcedwidth=120;
   $forcedheight=100;

   $sourcefile=$path.$name;
   $destfile=$path."thumb_".$name;
   
   //if actual width is smaller than forced, do not stretch
   $size=@getimagesize($sourcefile);
   if($size[0]<$forcedwidth) $forcedwidth=$size[0];
   if($size[1]<$forcedheight) $forcedheitgh=$size[1];
   
   //invoke the GD function
   if(preg_match("/jpg$/i",$sourcefile) || preg_match("/jpeg$/i",$sourcefile))
   {	   
	   resampimagejpg($forcedwidth, $forcedheight, $sourcefile, $destfile);
   }
   elseif(preg_match("/gif$/i",$sourcefile))
   {
	   resampimagegif($forcedwidth, $forcedheight, $sourcefile, $destfile);
   }
   elseif(preg_match("/png$/i",$sourcefile) or preg_match("/ping$/i",$sourcefile))
   {
	   resampimagepng($forcedwidth, $forcedheight, $sourcefile, $destfile);
   }
   else
   {
	   //do not resize, but only copy
	   copy($sourcefile,$destfile);
   }
   
   return $destfile;
}

//to trim some characters from the end of the string
function trimr($str,$count)
{
	return substr($str,0,strlen($str)-$count);
}

?>
